From f4675510a6c1b8b0624edb7f664bf35396082ed1 Mon Sep 17 00:00:00 2001
From: David Carlos <ddavidcarlos1392@gmail.com>
Date: Mar 16 2018 02:30:30 +0000
Subject: [PATCH 13/17] Add initializer module.


  - Removes from monitor the responsibility of manage kiskadee process.
  Now this will be done by the initializer module.

---

diff --git a/kiskadee/initializer.py b/kiskadee/initializer.py
new file mode 100644
index 0000000..c39304d
--- /dev/null
+++ b/kiskadee/initializer.py
@@ -0,0 +1,22 @@
+"""Initializes kiskadee components.
+
+This module will run monitor and runner as processes.
+"""
+
+from multiprocessing import Process
+
+import kiskadee.model
+import kiskadee.queue
+import kiskadee.database
+from kiskadee.runner import Runner
+from kiskadee.monitor import Monitor
+
+def init():
+    queues = kiskadee.queue.Queues()
+    db = kiskadee.database.Database()
+    monitor = Monitor(db, queues)
+    runner = Runner(queues)
+    Process(target=monitor.run,).start()
+    runner_process = Process(target=runner.run,)
+    runner_process.start()
+    runner_process.join()
diff --git a/kiskadee/monitor.py b/kiskadee/monitor.py
index 7f485c2..1996a0b 100644
--- a/kiskadee/monitor.py
+++ b/kiskadee/monitor.py
@@ -4,15 +4,12 @@ kiskadee monitors repositories checking for new project versions to be
 analyzed. This module provides such capabilities.
 """
 import threading
-from multiprocessing import Process
 import time
 import os
 import importlib
 
-import kiskadee.database
-from kiskadee.runner import Runner
-import kiskadee.queue
-from kiskadee.model import Package, Fetcher, Version, Report, Analysis
+import kiskadee
+from kiskadee.model import Package, Fetcher, Version, Report, Analysis, Analyzer
 
 RUNNING = True
 
@@ -23,9 +20,9 @@ class Monitor:
         """Return a non initialized Monitor."""
         self.db = db
         self.queues = queues
-        kiskadee.model.Analyzer.create_analyzers(self.db)
+        Analyzer.create_analyzers(self.db)
 
-    def start(self):
+    def run(self):
         kiskadee.logger.debug('Monitor PID: {}'.format(os.getpid()))
 
         for fetcher in kiskadee.load_fetchers():
@@ -86,21 +83,3 @@ class Monitor:
         module_as_a_thread.start()
         if joinable or timeout:
             module_as_a_thread.join(timeout)
-
-
-def daemon():
-    """Entry point to the monitor module."""
-    # TODO: improve with start/stop system
-    queues = kiskadee.queue.Queues()
-    db = kiskadee.database.Database()
-    monitor = Monitor(db, queues)
-    runner = Runner(queues)
-    monitor_process = Process(
-            target=monitor.start,
-        )
-    runner_process = Process(
-            target=runner.runner,
-        )
-    monitor_process.start()
-    runner_process.start()
-    runner_process.join()
diff --git a/kiskadee/runner.py b/kiskadee/runner.py
index 0dee08a..ea9ef60 100644
--- a/kiskadee/runner.py
+++ b/kiskadee/runner.py
@@ -22,7 +22,7 @@ class Runner:
         self.fetcher = None
         self.project = None
 
-    def runner(self):
+    def run(self):
         """Run static analyzers.
 
         Continuously dequeue packages from `analyses_queue` and call the
@@ -56,7 +56,7 @@ class Runner:
         return self.project
 
 
-    def clean_temporary_directory(self, temp_dir):
+    def rmdtemp(self, temp_dir):
         # not delete the source code used on tests.
         if not temp_dir.find("kiskadee/tests") > -1:
             shutil.rmtree(temp_dir)
@@ -78,7 +78,7 @@ class Runner:
                 analyzers, source_path
                 )
         self.enqueue_analysis_to_monitor(analysis_result)
-        self.clean_temporary_directory(source_path)
+        self.rmdtemp(source_path)
 
     def enqueue_analysis_to_monitor(self, analysis_result):
         if analysis_result['results']:
@@ -121,7 +121,7 @@ class Runner:
             uncompressed_source_path = self.uncompress_project_code(
                     compressed_source_path
                     )
-            self.clean_temporary_directory(os.path.dirname(compressed_source_path))
+            self.rmdtemp(os.path.dirname(compressed_source_path))
             return uncompressed_source_path
         else:
             kiskadee.logger.debug('RUNNER: invalid compressed source')
diff --git a/setup.py b/setup.py
index 03a13f3..9a74169 100644
--- a/setup.py
+++ b/setup.py
@@ -44,7 +44,7 @@ setup(
     packages=find_packages(),
     include_package_data=False,
     entry_points={'console_scripts': [
-            'kiskadee = kiskadee.monitor:daemon',
+        'kiskadee = kiskadee.initializer:init',
             'kiskadee_api = kiskadee.api.app:main',],
             'moksha.consumer': (
                 'anityaconsumer = kiskadee.fetchers.anitya:AnityaConsumer')},

